 # -*- coding: utf-8 -*-
__author__ = 'IPSHIV'
import xlrd
import os
import tkFileDialog
import codecs


dict = {1: ['1#АРПС 1.10#MNB.DLL#\n3##','##','##ООО-Заказчик#ФИО-Закачик#ООО-Подрядчик#ФИО-Подрядчик#########Строительство##ТСН-2001\n0#ТСН-2001 ; 2000\n50#Итого по всем разделам###\n50#Всего###\n'],
        4: ['10#0##Раздел. ', '\n50#Итого по разделу###\n'],
        5: ['10#0##Подраздел. ', '\n50#Итого по подразделу###\n'],
        17: ['20#1#','#','#0.00###5.98#0.00#2021.68#961.94#0.00#0.00#20.84#0.00###5.98#0.00#-1#','###\n'],
        18: ['20#1#','#','#0.00###5.98#0.00#2021.68#961.94#0.00#0.00#20.84#0.00###5.98#0.00#-1#','###\n']
 }

source = tkFileDialog.askdirectory()

files = os.listdir(source)
excel = filter(lambda x: x.endswith('.xls'), files)
print excel
for element in excel:
    source_read = source + "/" + element
    rb = xlrd.open_workbook(source_read)
    try:
        sheet = rb.sheet_by_name(u'Source')
    except xlrd.biffh.XLRDError:
        print element
        print('Wrong! Wrong! Wrong!')
    else:
        print ('Start working hard')
        num_rows = sheet.nrows - 4
        name = (element.replace('.xls','') + '.txt')
        print name
        print num_rows
        to_write = os.path.join(source, name)
        f = codecs.open(to_write, 'w', encoding='cp866')
        wtr = []
        for idx in range(num_rows):
            a = ''
            data = sheet.row_values(idx,0,28)
            if data[0] == 1:
                key = dict.get(data[0])
                try:
                    a = key[0] + data[6].encode('utf-8', errors='ignore') + key[1] + data[5].encode('utf-8', errors='ignore') + key[2]
                except AttributeError:
                    a = key[0] + str(data[6]).encode('utf-8', errors='ignore') + key[1] + str(data[5]).encode('utf-8', errors='ignore') + key[2]
                else:
                    a = key[0] + data[6].encode('utf-8', errors='ignore') + key[1] + data[5].encode('utf-8',errors='ignore') + key[2]
                wtr.append(a.decode('utf-8').encode('cp866', errors='ignore'))

            elif data[0] == 4 or data[0] == 5:
                key = dict.get(data[0])
                a = key[0] + data[6].encode('utf-8', errors='ignore') + key[1]
                wtr.append(a.decode('utf-8').encode('cp866', errors='ignore'))
            elif data[0] == 17 or data[0] == 18:
                key = dict.get(data[0])
                a = '20#1#' + data[5].encode('utf-8', errors='ignore') + "#" + data[7].encode('utf-8', errors='ignore') + \
                    "#" + data[6].encode('utf-8', errors='ignore') + "#55.03#47.48#0.00#0.00#" + \
                    str(data[27]).encode('utf-8', errors='ignore') + "#0.00###5.98#0.00#2021.68#961.94#0.00#0.00#20.84#0.00###5.98#0.00#-1#" + \
                    str(data[8]).encode('utf-8', errors='ignore') + key[3]
                wtr.append(a.decode('utf-8').encode('cp866', errors='ignore'))

        f.writelines("%s" % i.decode('cp866') for i in wtr)
        f.close()


